=== debian/changelog ===
openmm (8.1.2+dfsg-12) unstable; urgency=medium

  * Patch out CMake's CMP0042 (Closes: #1113359)

 -- Andrius Merkys <merkys@debian.org>  Mon, 29 Sep 2025 04:58:19 -0400

openmm (8.1.2+dfsg-11) unstable; urgency=medium

  * Team upload.
  * debian/tests: skip testMTSLangevinIntegrator
    testMTSIntegratorExplicit on armel
  * Build-Depends: python3-numpy-dev for numpy3 dh sequence

 -- Drew Parsons <dparsons@debian.org>  Fri, 21 Mar 2025 01:10:37 +0100

openmm (8.1.2+dfsg-10) unstable; urgency=medium

  * Team upload.
  * fix s390x python test skips
  * debian/tests: skip test2ParticlesNonbonded on armel

 -- Drew Parsons <dparsons@debian.org>  Thu, 20 Mar 2025 09:05:38 +0100

openmm (8.1.2+dfsg-9) unstable; urgency=medium

  * Team upload.
  * s390x (and hppa, sparc64): skip more tests that time out or fail

 -- Drew Parsons <dparsons@debian.org>  Wed, 19 Mar 2025 12:24:19 +0100

openmm (8.1.2+dfsg-8) unstable; urgency=medium

  * Team upload.
  * s390x (and hppa, sparc64): skip test_Constraints_charmm (python)
  * debian/tests Depends: dpkg-dev, gcc (for dpkg-architecture)

 -- Drew Parsons <dparsons@debian.org>  Tue, 18 Mar 2025 17:07:37 +0100

openmm (8.1.2+dfsg-7) unstable; urgency=medium

  * Team upload.
  * fix control of build-time python tests

 -- Drew Parsons <dparsons@debian.org>  Tue, 18 Mar 2025 02:40:00 +0100

openmm (8.1.2+dfsg-6) unstable; urgency=medium

  * Team upload.
  * skip TestATMForce python test on s390x (and hppa, sparc64)
  * run pytest verbose on arches requiring python test skips
  * update debian/tests
    - run pytest over all supported python versions
    - run verbose tests on armel

 -- Drew Parsons <dparsons@debian.org>  Mon, 17 Mar 2025 22:03:10 +0100

openmm (8.1.2+dfsg-5) unstable; urgency=medium

  * Team upload.
  * skip C++ tests (in ctest) failing for specific arches
  * skip MTSLangevinIntegrator in python (pybuild) tests
    (it tends to time out). Use pytest (for 'not' operator)

 -- Drew Parsons <dparsons@debian.org>  Sat, 15 Mar 2025 19:39:57 +0100

openmm (8.1.2+dfsg-4) unstable; urgency=medium

  * Team upload.
  * debian patch regex_escapes_PR4804.patch applies upstream PR#4804
    to fix regex escape strings. Closes: #1085752.
  * Build-Depends: python3-setuptools (uses setup.py not pyproject.toml)
    Closes: #1080690.

 -- Drew Parsons <dparsons@debian.org>  Wed, 19 Feb 2025 17:35:42 +0100

openmm (8.1.2+dfsg-3) unstable; urgency=medium

  * Backport upstream PR to fix Numpy 2 incompatibility (Closes: #1094700)
  * Bump copyright years.

 -- Andrius Merkys <merkys@debian.org>  Tue, 04 Feb 2025 04:54:26 -0500

openmm (8.1.2+dfsg-2) unstable; urgency=medium

  * Backport upstream PR to restore compatibility with scipy
    (Closes: #1090255).

 -- Andrius Merkys <merkys@debian.org>  Thu, 19 Dec 2024 07:43:03 -0500

openmm (8.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 8.1.2+dfsg

 -- Andrius Merkys <merkys@debian.org>  Tue, 10 Sep 2024 10:06:10 -0400
