=== debian/tests/control ===
Tests: test-python
Depends:
 python3-all,
 python3-openmm,
 python3-pytest,
 dpkg-dev, gcc
Restrictions:
 rw-build-tree,
